function [x0,v0]= init_BP_BP1(odefile, x, p, ap, bp)
%
% [x0,v0] = init_BP_BP1(odefile, x, p, ap, bp)
%
% Initializes a branch point continuation from a BP point
% 
%
global cds bpds gds

% check input
 if size(ap,2)~=2
     errordlg('Two active parameter are needed for a codim-1 Branchpoint bifurcation curve continuation');
 end
% initialize bpds
func_handles = feval(odefile);
bpds.dummypar_Idx=length(p)+1;
ap=[ap,bpds.dummypar_Idx];
p(bpds.dummypar_Idx)=0;

symord = 0; 
symordp = 0;
bpds.odefile = odefile;
% redefine the functions in order to get the dummy parameter
bpds.func = @(funz,varargin) bpfunc(func_handles{2},varargin);

if     ~isempty(func_handles{9})
    symord = 5; 
    bpds.Jacobian  = @(funz,varargin) bpJacobian(func_handles{3},varargin);
    bpds.Hessians  = @(funz,varargin) exceptlastone(func_handles{5},varargin);
    bpds.Der3 = @(funz,varargin) exceptlastone(func_handles{7},varargin);
    bpds.Der4 = @(funz,varargin) exceptlastone(func_handles{8},varargin);
    bpds.Der5 = @(funz,varargin) exceptlastone(func_handles{9},varargin);
elseif ~isempty(func_handles{8})
    symord = 4; 
    bpds.Jacobian  = @(funz,varargin) bpJacobian(func_handles{3},varargin);
    bpds.Hessians  = @(funz,varargin) exceptlastone(func_handles{5},varargin);
    bpds.Der3 = @(funz,varargin) exceptlastone(func_handles{7},varargin);
    bpds.Der4 = @(funz,varargin) exceptlastone(func_handles{8},varargin);
    bpds.Der5 = [];
elseif ~isempty(func_handles{7})   
    symord = 3; 
    bpds.Jacobian  = @(funz,varargin) bpJacobian(func_handles{3},varargin);
    bpds.Hessians  = @(funz,varargin) exceptlastone(func_handles{5},varargin);
    bpds.Der3 = @(funz,varargin) exceptlastone(func_handles{7},varargin);
    bpds.Der4 = [];
    bpds.Der5 = [];
elseif ~isempty(func_handles{5})   
    symord = 2; 
    bpds.Jacobian  = @(funz,varargin) bpJacobian(func_handles{3},varargin);
    bpds.Hessians  = @(funz,varargin) exceptlastone(func_handles{5},varargin);
    bpds.Der3 = [];
    bpds.Der4 = [];
    bpds.Der5 = [];
elseif ~isempty(func_handles{3})
    symord = 1; 
    bpds.Jacobian  = @(funz,varargin) bpJacobian(func_handles{3},varargin);
    bpds.Hessians  = [];
    bpds.Der3 = [];
    bpds.Der4 = [];
    bpds.Der5 = [];
else
    bpds.Jacobian  = [];
    bpds.Hessians  = [];
    bpds.Der3 = [];
    bpds.Der4 = [];
    bpds.Der5 = [];
end

if ~isempty(func_handles{6})
    symordp = 2; 
    bpds.JacobianP = @(funz,varargin) bpjacobianP(func_handles{4},varargin);
    bpds.HessiansP = @(funz,varargin) bphessianP(func_handles{6},varargin);
elseif ~isempty(func_handles{4})   
    symordp = 1;
    bpds.JacobianP = @(funz,varargin) bpjacobianP(func_handles{4},varargin);
    bpds.HessiansP = [];
else
    bpds.JacobianP = [];
    bpds.HessiansP = [];
end

siz = size(func_handles,2);
if siz > 9
    j=1;
    for i=10:siz
        bpds.user{j}= func_handles{i};
        j=j+1;
    end
end
bpds.nphase = size(x,1);
bpds.ActiveParams = ap;
gds.options.ActiveParams = ap;
bpds.BranchParam =  ap(1);
bpds.P0 = p;
x0 = x ; 
x0(bpds.nphase+(1:3),:) = p(ap);
if isempty(cds) || ~isfield(cds,'options')
    cds.options = contset();
end
cds.curve = @branchpoint1;
cds.ndim = length(x)+3;
[x,p] =rearr(x0); p = num2cell(p);

curvehandles = feval(cds.curve);
cds.curve_func = curvehandles{1};
cds.curve_options = curvehandles{3};
cds.curve_jacobian = curvehandles{4};
cds.curve_hessians = curvehandles{5};
cds.options = feval(cds.curve_options);
cds.options = contset(cds.options,'Increment',1e-5);
cds.options = contset(cds.options, 'SymDerivative', symord);
cds.options = contset(cds.options, 'SymDerivativeP', symordp);
cds.symjac = 1;
cds.symhess = 0;

% Add the bordering
bpds.joinvector=zeros(bpds.nphase,1);
jacobian=cjac(bpds.func,bpds.Jacobian,x,p,ap);
nphase=length(jacobian);
borderjac=[jacobian',rand(nphase,1);rand(1,nphase),0];
rhs=[zeros(nphase,1);1];
joinvector=borderjac\rhs;
joinvector=joinvector(1:nphase);
joinvector=joinvector/norm(joinvector);
bpds.joinvector=joinvector;

[Q,R,E]=qr([cjac(bpds.func,bpds.Jacobian,x,p,bpds.ActiveParams) cjacbr(bpds.func,bpds.JacobianP,x,p,bpds.ActiveParams,bpds.BranchParam)]);
bpds.borders.w=Q(:,end);
R(end,end)=0;
bpds.borders.v= E*[R(1:end-2,1:end-2)\-R(1:end-2,end-1:end);eye(2)];
% calculate eigenvalues
v0=[];
cds = rmfield(cds,'options');

%xxxxxxxxxxxxx
n = bpds.nphase;
a = reshape(1:(n^2),n,n);
[bia,bin,bip] = bialt(a);
if any(any(bip))
    [bpds.BiAlt_M1_I,bpds.BiAlt_M1_J,bpds.BiAlt_M1_V] = find(bip);
else
    bpds.BiAlt_M1_I=1;bpds.BiAlt_M1_J=1;bpds.BiAlt_M1_V=n^2+1;
end    
if any(any(bin))
    [bpds.BiAlt_M2_I,bpds.BiAlt_M2_J,bpds.BiAlt_M2_V] = find(bin);
else
     bpds.BiAlt_M2_I=1;bpds.BiAlt_M2_J=1;bpds.BiAlt_M2_V=n^2+1;
end
if any(any(bia))
    [bpds.BiAlt_M3_I,bpds.BiAlt_M3_J,bpds.BiAlt_M3_V] = find(bia);
else
    bpds.BiAlt_M3_I=1;bpds.BiAlt_M3_J=1;bpds.BiAlt_M3_V=n^2+1;
end

if bpds.nphase > 2
    jacobian(:,end+1) = 0;
    A1 = sparse(bpds.BiAlt_M1_I,bpds.BiAlt_M1_J,jacobian(bpds.BiAlt_M1_V));
    A2 = sparse(bpds.BiAlt_M2_I,bpds.BiAlt_M2_J,jacobian(bpds.BiAlt_M2_V));
    A3 = sparse(bpds.BiAlt_M3_I,bpds.BiAlt_M3_J,jacobian(bpds.BiAlt_M3_V));
    A = A1-A2+A3;
    [Q,R,E] = qr(full(A));
    bpds.bigW = Q(:,end);
    bpds.bigV = E(:,end);
    bpds.bigD = 0;
    bpds.adaptchoice = 1;
end




% ---------------------------------------------------------------
function [x,p] = rearr(x0)
% [x,p] = rearr(x0)
% Rearranges x0 into coordinates (x) and parameters (p)
global bpds
p = bpds.P0;
p(bpds.ActiveParams) = x0((bpds.nphase+1):end);
x = x0(1:bpds.nphase);



