function out = lpneuron
out{1} = @init;
out{2} = @fun_eval;
out{3} = @jacobian;
out{4} = @jacobianp;
out{5} = @hessians;
out{6} = @hessiansp;
out{7} = [];
out{8} = [];
out{9} = [];

% --------------------------------------------------------------------------
function dydt = fun_eval(t,kmrgd,par_Cm,par_kh,par_kc,par_kk,par_kaf,par_kas,par_kr,par_gna,par_gc1,par_gc2,par_gk,par_gkc,par_gaf,par_gas,par_gh,par_ena,par_eca,par_ek,par_eh,par_el,par_iext,par_vr,par_sr,par_cica,par_va,par_vk,par_sk,par_gl,par_vb)
dydt=[((par_gna*(1/(1+15*exp(-(kmrgd(1)+34)/13)*(1-exp(-(kmrgd(1)+6)/20))/(0.11*kmrgd(1)+0.66)))^3*kmrgd(2)*(par_ena-kmrgd(1)))+(par_gc1*kmrgd(4)*kmrgd(6)+par_gc2*kmrgd(5))*(par_eca-kmrgd(1))+par_gk*kmrgd(7)^4*(par_ek-kmrgd(1))+par_gkc*kmrgd(8)*kmrgd(9)*(par_ek-kmrgd(1))+(par_gaf*kmrgd(11)+par_gas*kmrgd(12))*kmrgd(10)^3*(par_ek-kmrgd(1))+par_gh*kmrgd(13)*(par_eh-kmrgd(1))+par_gl*(par_el-kmrgd(1))+par_iext)/par_Cm;
par_kh*(0.08*(1-kmrgd(2))*exp(-.125*(kmrgd(1)+39))-kmrgd(2)/(1+exp(-0.2*kmrgd(1)-8)));
-par_cica*(par_gc1*kmrgd(4)*kmrgd(6)+par_gc2*kmrgd(5))*(kmrgd(1)-par_eca)+par_kc*(0.05-kmrgd(3));
50/(1+exp(-(kmrgd(1)+11)/7))-50*kmrgd(4);
10/(1+exp(-(kmrgd(1)-22)/7))-10*kmrgd(5);
16/(1+exp((kmrgd(1)+50)/8))-16*kmrgd(6);
282*(1/(1+exp(-(kmrgd(1)+25)/17))-kmrgd(7))/(1+exp(-(kmrgd(1)-10)/22));
par_kk*kmrgd(3)/(1+exp(-(0.0434783*kmrgd(1)+0.026087*kmrgd(3)+0.869565)))/(1+exp(-(0.16667*kmrgd(1)+0.1*kmrgd(3)+3.83333)))/(2.5+kmrgd(3))-par_kk*kmrgd(8);
21/(0.6+kmrgd(3))-35*kmrgd(9);
140*(1/(1+exp(-(kmrgd(1)-par_va)/16))-kmrgd(10));
par_kaf*(1/(1+exp((kmrgd(1)-par_vb)/6))-kmrgd(11));
par_kas*(1/(1+exp((kmrgd(1)-par_vb)/6))-kmrgd(12));
par_kr*(1+exp((kmrgd(1)-par_vk)/par_sk))*(1/(1+exp((kmrgd(1)-par_vr)/par_sr))-kmrgd(13));];

% --------------------------------------------------------------------------
function [tspan,y0,options] = init
handles = feval(lpneuron);
y0=[0,0,0,0,0,0,0,0,0,0,0,0,0];
options = odeset('Jacobian',handles(3),'JacobianP',handles(4),'Hessians',handles(5),'HessiansP',handles(6));
tspan = [0 10];

% --------------------------------------------------------------------------
function jac = jacobian(t,kmrgd,par_Cm,par_kh,par_kc,par_kk,par_kaf,par_kas,par_kr,par_gna,par_gc1,par_gc2,par_gk,par_gkc,par_gaf,par_gas,par_gh,par_ena,par_eca,par_ek,par_eh,par_el,par_iext,par_vr,par_sr,par_cica,par_va,par_vk,par_sk,par_gl,par_vb)
jac=[ -(par_gl + kmrgd(5)*par_gc2 + kmrgd(13)*par_gh + kmrgd(7)^4*par_gk + kmrgd(10)^3*(kmrgd(11)*par_gaf + kmrgd(12)*par_gas) - (kmrgd(2)*par_gna)/((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^3 + kmrgd(4)*kmrgd(6)*par_gc1 + kmrgd(8)*kmrgd(9)*par_gkc - (3*kmrgd(2)*par_gna*(kmrgd(1) - par_ena)*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(13*((11*kmrgd(1))/100 + 33/50)) + (33*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(20*((11*kmrgd(1))/100 + 33/50)^2) + (3*exp(- kmrgd(1)/20 - 3/10)*exp(- kmrgd(1)/13 - 34/13))/(4*((11*kmrgd(1))/100 + 33/50))))/((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^4)/par_Cm , (par_gna*(kmrgd(1) - par_ena))/(par_Cm*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^3) , 0 , -(kmrgd(6)*par_gc1*(kmrgd(1) - par_eca))/par_Cm , -(par_gc2*(kmrgd(1) - par_eca))/par_Cm , -(kmrgd(4)*par_gc1*(kmrgd(1) - par_eca))/par_Cm , -(4*kmrgd(7)^3*par_gk*(kmrgd(1) - par_ek))/par_Cm , -(kmrgd(9)*par_gkc*(kmrgd(1) - par_ek))/par_Cm , -(kmrgd(8)*par_gkc*(kmrgd(1) - par_ek))/par_Cm , -(3*kmrgd(10)^2*(kmrgd(1) - par_ek)*(kmrgd(11)*par_gaf + kmrgd(12)*par_gas))/par_Cm , -(kmrgd(10)^3*par_gaf*(kmrgd(1) - par_ek))/par_Cm , -(kmrgd(10)^3*par_gas*(kmrgd(1) - par_ek))/par_Cm , -(par_gh*(kmrgd(1) - par_eh))/par_Cm ; par_kh*((exp(- kmrgd(1)/8 - 39/8)*((2*kmrgd(2))/25 - 2/25))/8 - (kmrgd(2)*exp(- kmrgd(1)/5 - 8))/(5*(exp(- kmrgd(1)/5 - 8) + 1)^2)) , -par_kh*((2*exp(- kmrgd(1)/8 - 39/8))/25 + 1/(exp(- kmrgd(1)/5 - 8) + 1)) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; -par_cica*(kmrgd(5)*par_gc2 + kmrgd(4)*kmrgd(6)*par_gc1) , 0 , -par_kc , -kmrgd(6)*par_gc1*par_cica*(kmrgd(1) - par_eca) , -par_gc2*par_cica*(kmrgd(1) - par_eca) , -kmrgd(4)*par_gc1*par_cica*(kmrgd(1) - par_eca) , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (50*exp(- kmrgd(1)/7 - 11/7))/(7*(exp(- kmrgd(1)/7 - 11/7) + 1)^2) , 0 , 0 , -50 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (10*exp(22/7 - kmrgd(1)/7))/(7*(exp(22/7 - kmrgd(1)/7) + 1)^2) , 0 , 0 , 0 , -10 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; -(2*exp(kmrgd(1)/8 + 25/4))/(exp(kmrgd(1)/8 + 25/4) + 1)^2 , 0 , 0 , 0 , 0 , -16 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (282*exp(- kmrgd(1)/17 - 25/17))/(17*(exp(5/11 - kmrgd(1)/22) + 1)*(exp(- kmrgd(1)/17 - 25/17) + 1)^2) - (exp(5/11 - kmrgd(1)/22)*(282*kmrgd(7) - 282/(exp(- kmrgd(1)/17 - 25/17) + 1)))/(22*(exp(5/11 - kmrgd(1)/22) + 1)^2) , 0 , 0 , 0 , 0 , 0 , -282/(exp(5/11 - kmrgd(1)/22) + 1) , 0 , 0 , 0 , 0 , 0 , 0 ; (1566470845429621*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992))/(36028797018963968*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (16667*kmrgd(3)*par_kk*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(100000*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) , 0 , par_kk/((exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) - (kmrgd(3)*par_kk)/((exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)^2*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (939883227833713*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992))/(36028797018963968*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (kmrgd(3)*par_kk*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(10*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) , 0 , 0 , 0 , 0 , -par_kk , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , -21/(kmrgd(3) + 3/5)^2 , 0 , 0 , 0 , 0 , 0 , -35 , 0 , 0 , 0 , 0 ; (35*exp(par_va/16 - kmrgd(1)/16))/(4*(exp(par_va/16 - kmrgd(1)/16) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , -140 , 0 , 0 , 0 ; -(par_kaf*exp(kmrgd(1)/6 - par_vb/6))/(6*(exp(kmrgd(1)/6 - par_vb/6) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , -par_kaf , 0 , 0 ; -(par_kas*exp(kmrgd(1)/6 - par_vb/6))/(6*(exp(kmrgd(1)/6 - par_vb/6) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , -par_kas , 0 ; - (par_kr*exp((kmrgd(1) - par_vk)/par_sk)*(kmrgd(13) - 1/(exp((kmrgd(1) - par_vr)/par_sr) + 1)))/par_sk - (par_kr*exp((kmrgd(1) - par_vr)/par_sr)*(exp((kmrgd(1) - par_vk)/par_sk) + 1))/(par_sr*(exp((kmrgd(1) - par_vr)/par_sr) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , -par_kr*(exp((kmrgd(1) - par_vk)/par_sk) + 1) ];
% --------------------------------------------------------------------------
function jacp = jacobianp(t,kmrgd,par_Cm,par_kh,par_kc,par_kk,par_kaf,par_kas,par_kr,par_gna,par_gc1,par_gc2,par_gk,par_gkc,par_gaf,par_gas,par_gh,par_ena,par_eca,par_ek,par_eh,par_el,par_iext,par_vr,par_sr,par_cica,par_va,par_vk,par_sk,par_gl,par_vb)
jacp=[ ((kmrgd(5)*par_gc2 + kmrgd(4)*kmrgd(6)*par_gc1)*(kmrgd(1) - par_eca) - par_iext + par_gl*(kmrgd(1) - par_el) + kmrgd(7)^4*par_gk*(kmrgd(1) - par_ek) + kmrgd(10)^3*(kmrgd(1) - par_ek)*(kmrgd(11)*par_gaf + kmrgd(12)*par_gas) + kmrgd(13)*par_gh*(kmrgd(1) - par_eh) + kmrgd(8)*kmrgd(9)*par_gkc*(kmrgd(1) - par_ek) - (kmrgd(2)*par_gna*(kmrgd(1) - par_ena))/((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^3)/par_Cm^2 , 0 , 0 , 0 , 0 , 0 , 0 , (kmrgd(2)*(kmrgd(1) - par_ena))/(par_Cm*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^3) , -(kmrgd(4)*kmrgd(6)*(kmrgd(1) - par_eca))/par_Cm , -(kmrgd(5)*(kmrgd(1) - par_eca))/par_Cm , -(kmrgd(7)^4*(kmrgd(1) - par_ek))/par_Cm , -(kmrgd(8)*kmrgd(9)*(kmrgd(1) - par_ek))/par_Cm , -(kmrgd(10)^3*kmrgd(11)*(kmrgd(1) - par_ek))/par_Cm , -(kmrgd(10)^3*kmrgd(12)*(kmrgd(1) - par_ek))/par_Cm , -(kmrgd(13)*(kmrgd(1) - par_eh))/par_Cm , -(kmrgd(2)*par_gna)/(par_Cm*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^3) , (kmrgd(5)*par_gc2 + kmrgd(4)*kmrgd(6)*par_gc1)/par_Cm , (kmrgd(7)^4*par_gk + kmrgd(10)^3*(kmrgd(11)*par_gaf + kmrgd(12)*par_gas) + kmrgd(8)*kmrgd(9)*par_gkc)/par_Cm , (kmrgd(13)*par_gh)/par_Cm , par_gl/par_Cm , 1/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , -(kmrgd(1) - par_el)/par_Cm , 0 ; 0 , - exp(- kmrgd(1)/8 - 39/8)*((2*kmrgd(2))/25 - 2/25) - kmrgd(2)/(exp(- kmrgd(1)/5 - 8) + 1) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 1/20 - kmrgd(3) , 0 , 0 , 0 , 0 , 0 , -kmrgd(4)*kmrgd(6)*par_cica*(kmrgd(1) - par_eca) , -kmrgd(5)*par_cica*(kmrgd(1) - par_eca) , 0 , 0 , 0 , 0 , 0 , 0 , par_cica*(kmrgd(5)*par_gc2 + kmrgd(4)*kmrgd(6)*par_gc1) , 0 , 0 , 0 , 0 , 0 , 0 , -(kmrgd(5)*par_gc2 + kmrgd(4)*kmrgd(6)*par_gc1)*(kmrgd(1) - par_eca) , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , kmrgd(3)/((exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) - kmrgd(8) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , -(35*exp(par_va/16 - kmrgd(1)/16))/(4*(exp(par_va/16 - kmrgd(1)/16) + 1)^2) , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 1/(exp(kmrgd(1)/6 - par_vb/6) + 1) - kmrgd(11) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , (par_kaf*exp(kmrgd(1)/6 - par_vb/6))/(6*(exp(kmrgd(1)/6 - par_vb/6) + 1)^2) ; 0 , 0 , 0 , 0 , 0 , 1/(exp(kmrgd(1)/6 - par_vb/6) + 1) - kmrgd(12) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , (par_kas*exp(kmrgd(1)/6 - par_vb/6))/(6*(exp(kmrgd(1)/6 - par_vb/6) + 1)^2) ; 0 , 0 , 0 , 0 , 0 , 0 , -(kmrgd(13) - 1/(exp((kmrgd(1) - par_vr)/par_sr) + 1))*(exp((kmrgd(1) - par_vk)/par_sk) + 1) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , (par_kr*exp((kmrgd(1) - par_vr)/par_sr)*(exp((kmrgd(1) - par_vk)/par_sk) + 1))/(par_sr*(exp((kmrgd(1) - par_vr)/par_sr) + 1)^2) , (par_kr*exp((kmrgd(1) - par_vr)/par_sr)*(exp((kmrgd(1) - par_vk)/par_sk) + 1)*(kmrgd(1) - par_vr))/(par_sr^2*(exp((kmrgd(1) - par_vr)/par_sr) + 1)^2) , 0 , 0 , (par_kr*exp((kmrgd(1) - par_vk)/par_sk)*(kmrgd(13) - 1/(exp((kmrgd(1) - par_vr)/par_sr) + 1)))/par_sk , (par_kr*exp((kmrgd(1) - par_vk)/par_sk)*(kmrgd(13) - 1/(exp((kmrgd(1) - par_vr)/par_sr) + 1))*(kmrgd(1) - par_vk))/par_sk^2 , 0 , 0 ];
% --------------------------------------------------------------------------
function hess = hessians(t,kmrgd,par_Cm,par_kh,par_kc,par_kk,par_kaf,par_kas,par_kr,par_gna,par_gc1,par_gc2,par_gk,par_gkc,par_gaf,par_gas,par_gh,par_ena,par_eca,par_ek,par_eh,par_el,par_iext,par_vr,par_sr,par_cica,par_va,par_vk,par_sk,par_gl,par_vb)
hess1=[ ((6*kmrgd(2)*par_gna*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(13*((11*kmrgd(1))/100 + 33/50)) + (33*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(20*((11*kmrgd(1))/100 + 33/50)^2) + (3*exp(- kmrgd(1)/20 - 3/10)*exp(- kmrgd(1)/13 - 34/13))/(4*((11*kmrgd(1))/100 + 33/50))))/((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^4 - (3*kmrgd(2)*par_gna*(kmrgd(1) - par_ena)*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(169*((11*kmrgd(1))/100 + 33/50)) + (33*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(130*((11*kmrgd(1))/100 + 33/50)^2) + (363*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(1000*((11*kmrgd(1))/100 + 33/50)^3) + (159*exp(- kmrgd(1)/20 - 3/10)*exp(- kmrgd(1)/13 - 34/13))/(1040*((11*kmrgd(1))/100 + 33/50)) + (33*exp(- kmrgd(1)/20 - 3/10)*exp(- kmrgd(1)/13 - 34/13))/(200*((11*kmrgd(1))/100 + 33/50)^2)))/((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^4 + (12*kmrgd(2)*par_gna*(kmrgd(1) - par_ena)*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(13*((11*kmrgd(1))/100 + 33/50)) + (33*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(20*((11*kmrgd(1))/100 + 33/50)^2) + (3*exp(- kmrgd(1)/20 - 3/10)*exp(- kmrgd(1)/13 - 34/13))/(4*((11*kmrgd(1))/100 + 33/50)))^2)/((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^5)/par_Cm , par_gna/(par_Cm*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^3) + (3*par_gna*(kmrgd(1) - par_ena)*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(13*((11*kmrgd(1))/100 + 33/50)) + (33*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(20*((11*kmrgd(1))/100 + 33/50)^2) + (3*exp(- kmrgd(1)/20 - 3/10)*exp(- kmrgd(1)/13 - 34/13))/(4*((11*kmrgd(1))/100 + 33/50))))/(par_Cm*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^4) , 0 , -(kmrgd(6)*par_gc1)/par_Cm , -par_gc2/par_Cm , -(kmrgd(4)*par_gc1)/par_Cm , -(4*kmrgd(7)^3*par_gk)/par_Cm , -(kmrgd(9)*par_gkc)/par_Cm , -(kmrgd(8)*par_gkc)/par_Cm , -(3*kmrgd(10)^2*(kmrgd(11)*par_gaf + kmrgd(12)*par_gas))/par_Cm , -(kmrgd(10)^3*par_gaf)/par_Cm , -(kmrgd(10)^3*par_gas)/par_Cm , -par_gh/par_Cm ; -par_kh*((exp(- kmrgd(1)/8 - 39/8)*((2*kmrgd(2))/25 - 2/25))/64 - (kmrgd(2)*exp(- kmrgd(1)/5 - 8))/(25*(exp(- kmrgd(1)/5 - 8) + 1)^2) + (2*kmrgd(2)*exp(- (2*kmrgd(1))/5 - 16))/(25*(exp(- kmrgd(1)/5 - 8) + 1)^3)) , par_kh*(exp(- kmrgd(1)/8 - 39/8)/100 - exp(- kmrgd(1)/5 - 8)/(5*(exp(- kmrgd(1)/5 - 8) + 1)^2)) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , -kmrgd(6)*par_gc1*par_cica , -par_gc2*par_cica , -kmrgd(4)*par_gc1*par_cica , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (100*exp(- (2*kmrgd(1))/7 - 22/7))/(49*(exp(- kmrgd(1)/7 - 11/7) + 1)^3) - (50*exp(- kmrgd(1)/7 - 11/7))/(49*(exp(- kmrgd(1)/7 - 11/7) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (20*exp(44/7 - (2*kmrgd(1))/7))/(49*(exp(22/7 - kmrgd(1)/7) + 1)^3) - (10*exp(22/7 - kmrgd(1)/7))/(49*(exp(22/7 - kmrgd(1)/7) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; exp(kmrgd(1)/4 + 25/2)/(2*(exp(kmrgd(1)/8 + 25/4) + 1)^3) - exp(kmrgd(1)/8 + 25/4)/(4*(exp(kmrgd(1)/8 + 25/4) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (564*exp(- (2*kmrgd(1))/17 - 50/17))/(289*(exp(5/11 - kmrgd(1)/22) + 1)*(exp(- kmrgd(1)/17 - 25/17) + 1)^3) - (282*exp(- kmrgd(1)/17 - 25/17))/(289*(exp(5/11 - kmrgd(1)/22) + 1)*(exp(- kmrgd(1)/17 - 25/17) + 1)^2) - (exp(10/11 - kmrgd(1)/11)*(282*kmrgd(7) - 282/(exp(- kmrgd(1)/17 - 25/17) + 1)))/(242*(exp(5/11 - kmrgd(1)/22) + 1)^3) + (exp(5/11 - kmrgd(1)/22)*(282*kmrgd(7) - 282/(exp(- kmrgd(1)/17 - 25/17) + 1)))/(484*(exp(5/11 - kmrgd(1)/22) + 1)^2) + (282*exp(5/11 - kmrgd(1)/22)*exp(- kmrgd(1)/17 - 25/17))/(187*(exp(5/11 - kmrgd(1)/22) + 1)^2*(exp(- kmrgd(1)/17 - 25/17) + 1)^2) , 0 , 0 , 0 , 0 , 0 , -(141*exp(5/11 - kmrgd(1)/22))/(11*(exp(5/11 - kmrgd(1)/22) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 ; (2453830909580991566984064203641*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/18014398509481984 - (939883227833713*kmrgd(3))/18014398509481984 - 7832345219948851/4503599627370496))/(649037107316853453566312041152512*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^3*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) - (2453830909580991566984064203641*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992))/(1298074214633706907132624082305024*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (277788889*kmrgd(3)*par_kk*exp(- (16667*kmrgd(1))/50000 - kmrgd(3)/5 - 1078986472474259/140737488355328))/(5000000000*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^3) - (277788889*kmrgd(3)*par_kk*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(10000000000*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) + (26108369580775493207*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992)*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(1801439850948198400000*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) , 0 , (1566470845429621*par_kk*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992))/(36028797018963968*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (16667*par_kk*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(100000*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) - (1472299674509797494822632612773*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992))/(1298074214633706907132624082305024*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (1472299674509797494822632612773*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/18014398509481984 - (939883227833713*kmrgd(3))/18014398509481984 - 7832345219948851/4503599627370496))/(649037107316853453566312041152512*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^3*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) - (1566470845429621*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992))/(36028797018963968*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)^2*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (16667*kmrgd(3)*par_kk*exp(- (16667*kmrgd(1))/50000 - kmrgd(3)/5 - 1078986472474259/140737488355328))/(500000*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^3) - (16667*kmrgd(3)*par_kk*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(1000000*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) - (16667*kmrgd(3)*par_kk*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(100000*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)^2*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) + (31329742212600704571*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992)*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(3602879701896396800000*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (35*exp(par_va/8 - kmrgd(1)/8))/(32*(exp(par_va/16 - kmrgd(1)/16) + 1)^3) - (35*exp(par_va/16 - kmrgd(1)/16))/(64*(exp(par_va/16 - kmrgd(1)/16) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (par_kaf*exp(kmrgd(1)/3 - par_vb/3))/(18*(exp(kmrgd(1)/6 - par_vb/6) + 1)^3) - (par_kaf*exp(kmrgd(1)/6 - par_vb/6))/(36*(exp(kmrgd(1)/6 - par_vb/6) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (par_kas*exp(kmrgd(1)/3 - par_vb/3))/(18*(exp(kmrgd(1)/6 - par_vb/6) + 1)^3) - (par_kas*exp(kmrgd(1)/6 - par_vb/6))/(36*(exp(kmrgd(1)/6 - par_vb/6) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (2*par_kr*exp((2*(kmrgd(1) - par_vr))/par_sr)*(exp((kmrgd(1) - par_vk)/par_sk) + 1))/(par_sr^2*(exp((kmrgd(1) - par_vr)/par_sr) + 1)^3) - (par_kr*exp((kmrgd(1) - par_vr)/par_sr)*(exp((kmrgd(1) - par_vk)/par_sk) + 1))/(par_sr^2*(exp((kmrgd(1) - par_vr)/par_sr) + 1)^2) - (par_kr*exp((kmrgd(1) - par_vk)/par_sk)*(kmrgd(13) - 1/(exp((kmrgd(1) - par_vr)/par_sr) + 1)))/par_sk^2 - (2*par_kr*exp((kmrgd(1) - par_vk)/par_sk)*exp((kmrgd(1) - par_vr)/par_sr))/(par_sk*par_sr*(exp((kmrgd(1) - par_vr)/par_sr) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , -(par_kr*exp((kmrgd(1) - par_vk)/par_sk))/par_sk ];
hess2=[ (par_gna/((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^3 + (3*par_gna*(kmrgd(1) - par_ena)*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(13*((11*kmrgd(1))/100 + 33/50)) + (33*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(20*((11*kmrgd(1))/100 + 33/50)^2) + (3*exp(- kmrgd(1)/20 - 3/10)*exp(- kmrgd(1)/13 - 34/13))/(4*((11*kmrgd(1))/100 + 33/50))))/((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^4)/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; par_kh*(exp(- kmrgd(1)/8 - 39/8)/100 - exp(- kmrgd(1)/5 - 8)/(5*(exp(- kmrgd(1)/5 - 8) + 1)^2)) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess3=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (1566470845429621*par_kk*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992))/(36028797018963968*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (16667*par_kk*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(100000*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) - (1472299674509797494822632612773*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992))/(1298074214633706907132624082305024*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (1472299674509797494822632612773*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/18014398509481984 - (939883227833713*kmrgd(3))/18014398509481984 - 7832345219948851/4503599627370496))/(649037107316853453566312041152512*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^3*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) - (1566470845429621*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992))/(36028797018963968*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)^2*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (16667*kmrgd(3)*par_kk*exp(- (16667*kmrgd(1))/50000 - kmrgd(3)/5 - 1078986472474259/140737488355328))/(500000*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^3) - (16667*kmrgd(3)*par_kk*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(1000000*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) - (16667*kmrgd(3)*par_kk*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(100000*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)^2*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) + (31329742212600704571*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992)*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(3602879701896396800000*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) , 0 , (939883227833713*par_kk*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992))/(18014398509481984*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) - (2*par_kk)/((exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)^2*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (2*kmrgd(3)*par_kk)/((exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)^3*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (par_kk*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(5*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) - (883380481963119259358779366369*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992))/(1298074214633706907132624082305024*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (883380481963119259358779366369*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/18014398509481984 - (939883227833713*kmrgd(3))/18014398509481984 - 7832345219948851/4503599627370496))/(649037107316853453566312041152512*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^3*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) - (939883227833713*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992))/(18014398509481984*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)^2*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (kmrgd(3)*par_kk*exp(- (16667*kmrgd(1))/50000 - kmrgd(3)/5 - 1078986472474259/140737488355328))/(50*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^3) - (kmrgd(3)*par_kk*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(100*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) - (kmrgd(3)*par_kk*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(5*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)^2*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) + (939883227833713*kmrgd(3)*par_kk*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992)*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(180143985094819840*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 42/(kmrgd(3) + 3/5)^3 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess4=[ -(kmrgd(6)*par_gc1)/par_Cm , 0 , 0 , 0 , 0 , -(par_gc1*(kmrgd(1) - par_eca))/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; -kmrgd(6)*par_gc1*par_cica , 0 , 0 , 0 , 0 , -par_gc1*par_cica*(kmrgd(1) - par_eca) , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess5=[ -par_gc2/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; -par_gc2*par_cica , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess6=[ -(kmrgd(4)*par_gc1)/par_Cm , 0 , 0 , -(par_gc1*(kmrgd(1) - par_eca))/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; -kmrgd(4)*par_gc1*par_cica , 0 , 0 , -par_gc1*par_cica*(kmrgd(1) - par_eca) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess7=[ -(4*kmrgd(7)^3*par_gk)/par_Cm , 0 , 0 , 0 , 0 , 0 , -(12*kmrgd(7)^2*par_gk*(kmrgd(1) - par_ek))/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; -(141*exp(5/11 - kmrgd(1)/22))/(11*(exp(5/11 - kmrgd(1)/22) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess8=[ -(kmrgd(9)*par_gkc)/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , 0 , -(par_gkc*(kmrgd(1) - par_ek))/par_Cm , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess9=[ -(kmrgd(8)*par_gkc)/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , -(par_gkc*(kmrgd(1) - par_ek))/par_Cm , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess10=[ -(3*kmrgd(10)^2*(kmrgd(11)*par_gaf + kmrgd(12)*par_gas))/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , -(6*kmrgd(10)*(kmrgd(1) - par_ek)*(kmrgd(11)*par_gaf + kmrgd(12)*par_gas))/par_Cm , -(3*kmrgd(10)^2*par_gaf*(kmrgd(1) - par_ek))/par_Cm , -(3*kmrgd(10)^2*par_gas*(kmrgd(1) - par_ek))/par_Cm , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess11=[ -(kmrgd(10)^3*par_gaf)/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , -(3*kmrgd(10)^2*par_gaf*(kmrgd(1) - par_ek))/par_Cm , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess12=[ -(kmrgd(10)^3*par_gas)/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , -(3*kmrgd(10)^2*par_gas*(kmrgd(1) - par_ek))/par_Cm , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess13=[ -par_gh/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; -(par_kr*exp((kmrgd(1) - par_vk)/par_sk))/par_sk , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hess(:,:,1) =hess1;
hess(:,:,2) =hess2;
hess(:,:,3) =hess3;
hess(:,:,4) =hess4;
hess(:,:,5) =hess5;
hess(:,:,6) =hess6;
hess(:,:,7) =hess7;
hess(:,:,8) =hess8;
hess(:,:,9) =hess9;
hess(:,:,10) =hess10;
hess(:,:,11) =hess11;
hess(:,:,12) =hess12;
hess(:,:,13) =hess13;
% --------------------------------------------------------------------------
function hessp = hessiansp(t,kmrgd,par_Cm,par_kh,par_kc,par_kk,par_kaf,par_kas,par_kr,par_gna,par_gc1,par_gc2,par_gk,par_gkc,par_gaf,par_gas,par_gh,par_ena,par_eca,par_ek,par_eh,par_el,par_iext,par_vr,par_sr,par_cica,par_va,par_vk,par_sk,par_gl,par_vb)
hessp1=[ (par_gl + kmrgd(5)*par_gc2 + kmrgd(13)*par_gh + kmrgd(7)^4*par_gk + kmrgd(10)^3*(kmrgd(11)*par_gaf + kmrgd(12)*par_gas) - (kmrgd(2)*par_gna)/((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^3 + kmrgd(4)*kmrgd(6)*par_gc1 + kmrgd(8)*kmrgd(9)*par_gkc - (3*kmrgd(2)*par_gna*(kmrgd(1) - par_ena)*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(13*((11*kmrgd(1))/100 + 33/50)) + (33*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(20*((11*kmrgd(1))/100 + 33/50)^2) + (3*exp(- kmrgd(1)/20 - 3/10)*exp(- kmrgd(1)/13 - 34/13))/(4*((11*kmrgd(1))/100 + 33/50))))/((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^4)/par_Cm^2 , -(par_gna*(kmrgd(1) - par_ena))/(par_Cm^2*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^3) , 0 , (kmrgd(6)*par_gc1*(kmrgd(1) - par_eca))/par_Cm^2 , (par_gc2*(kmrgd(1) - par_eca))/par_Cm^2 , (kmrgd(4)*par_gc1*(kmrgd(1) - par_eca))/par_Cm^2 , (4*kmrgd(7)^3*par_gk*(kmrgd(1) - par_ek))/par_Cm^2 , (kmrgd(9)*par_gkc*(kmrgd(1) - par_ek))/par_Cm^2 , (kmrgd(8)*par_gkc*(kmrgd(1) - par_ek))/par_Cm^2 , (3*kmrgd(10)^2*(kmrgd(1) - par_ek)*(kmrgd(11)*par_gaf + kmrgd(12)*par_gas))/par_Cm^2 , (kmrgd(10)^3*par_gaf*(kmrgd(1) - par_ek))/par_Cm^2 , (kmrgd(10)^3*par_gas*(kmrgd(1) - par_ek))/par_Cm^2 , (par_gh*(kmrgd(1) - par_eh))/par_Cm^2 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp2=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (exp(- kmrgd(1)/8 - 39/8)*((2*kmrgd(2))/25 - 2/25))/8 - (kmrgd(2)*exp(- kmrgd(1)/5 - 8))/(5*(exp(- kmrgd(1)/5 - 8) + 1)^2) , - (2*exp(- kmrgd(1)/8 - 39/8))/25 - 1/(exp(- kmrgd(1)/5 - 8) + 1) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp3=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , -1 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp4=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (1566470845429621*kmrgd(3)*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992))/(36028797018963968*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (16667*kmrgd(3)*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(100000*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) , 0 , 1/((exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) - kmrgd(3)/((exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)^2*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (939883227833713*kmrgd(3)*exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992))/(36028797018963968*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)^2*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)) + (kmrgd(3)*exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656))/(10*(exp(- (1566470845429621*kmrgd(1))/36028797018963968 - (939883227833713*kmrgd(3))/36028797018963968 - 7832345219948851/9007199254740992) + 1)*(kmrgd(3) + 5/2)*(exp(- (16667*kmrgd(1))/100000 - kmrgd(3)/10 - 1078986472474259/281474976710656) + 1)^2) , 0 , 0 , 0 , 0 , -1 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp5=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; -exp(kmrgd(1)/6 - par_vb/6)/(6*(exp(kmrgd(1)/6 - par_vb/6) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , -1 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp6=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; -exp(kmrgd(1)/6 - par_vb/6)/(6*(exp(kmrgd(1)/6 - par_vb/6) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , -1 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp7=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; - (exp((kmrgd(1) - par_vk)/par_sk)*(kmrgd(13) - 1/(exp((kmrgd(1) - par_vr)/par_sr) + 1)))/par_sk - (exp((kmrgd(1) - par_vr)/par_sr)*(exp((kmrgd(1) - par_vk)/par_sk) + 1))/(par_sr*(exp((kmrgd(1) - par_vr)/par_sr) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , - exp((kmrgd(1) - par_vk)/par_sk) - 1 ];
hessp8=[ (kmrgd(2)/((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^3 + (3*kmrgd(2)*(kmrgd(1) - par_ena)*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(13*((11*kmrgd(1))/100 + 33/50)) + (33*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(20*((11*kmrgd(1))/100 + 33/50)^2) + (3*exp(- kmrgd(1)/20 - 3/10)*exp(- kmrgd(1)/13 - 34/13))/(4*((11*kmrgd(1))/100 + 33/50))))/((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^4)/par_Cm , (kmrgd(1) - par_ena)/(par_Cm*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^3) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp9=[ -(kmrgd(4)*kmrgd(6))/par_Cm , 0 , 0 , -(kmrgd(6)*(kmrgd(1) - par_eca))/par_Cm , 0 , -(kmrgd(4)*(kmrgd(1) - par_eca))/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; -kmrgd(4)*kmrgd(6)*par_cica , 0 , 0 , -kmrgd(6)*par_cica*(kmrgd(1) - par_eca) , 0 , -kmrgd(4)*par_cica*(kmrgd(1) - par_eca) , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp10=[ -kmrgd(5)/par_Cm , 0 , 0 , 0 , -(kmrgd(1) - par_eca)/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; -kmrgd(5)*par_cica , 0 , 0 , 0 , -par_cica*(kmrgd(1) - par_eca) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp11=[ -kmrgd(7)^4/par_Cm , 0 , 0 , 0 , 0 , 0 , -(4*kmrgd(7)^3*(kmrgd(1) - par_ek))/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp12=[ -(kmrgd(8)*kmrgd(9))/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , -(kmrgd(9)*(kmrgd(1) - par_ek))/par_Cm , -(kmrgd(8)*(kmrgd(1) - par_ek))/par_Cm , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp13=[ -(kmrgd(10)^3*kmrgd(11))/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , -(3*kmrgd(10)^2*kmrgd(11)*(kmrgd(1) - par_ek))/par_Cm , -(kmrgd(10)^3*(kmrgd(1) - par_ek))/par_Cm , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp14=[ -(kmrgd(10)^3*kmrgd(12))/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , -(3*kmrgd(10)^2*kmrgd(12)*(kmrgd(1) - par_ek))/par_Cm , 0 , -(kmrgd(10)^3*(kmrgd(1) - par_ek))/par_Cm , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp15=[ -kmrgd(13)/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , -(kmrgd(1) - par_eh)/par_Cm ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp16=[ -(3*kmrgd(2)*par_gna*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(13*((11*kmrgd(1))/100 + 33/50)) + (33*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/(20*((11*kmrgd(1))/100 + 33/50)^2) + (3*exp(- kmrgd(1)/20 - 3/10)*exp(- kmrgd(1)/13 - 34/13))/(4*((11*kmrgd(1))/100 + 33/50))))/(par_Cm*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^4) , -par_gna/(par_Cm*((15*exp(- kmrgd(1)/13 - 34/13)*(exp(- kmrgd(1)/20 - 3/10) - 1))/((11*kmrgd(1))/100 + 33/50) - 1)^3) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp17=[ 0 , 0 , 0 , (kmrgd(6)*par_gc1)/par_Cm , par_gc2/par_Cm , (kmrgd(4)*par_gc1)/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , kmrgd(6)*par_gc1*par_cica , par_gc2*par_cica , kmrgd(4)*par_gc1*par_cica , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp18=[ 0 , 0 , 0 , 0 , 0 , 0 , (4*kmrgd(7)^3*par_gk)/par_Cm , (kmrgd(9)*par_gkc)/par_Cm , (kmrgd(8)*par_gkc)/par_Cm , (3*kmrgd(10)^2*(kmrgd(11)*par_gaf + kmrgd(12)*par_gas))/par_Cm , (kmrgd(10)^3*par_gaf)/par_Cm , (kmrgd(10)^3*par_gas)/par_Cm , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp19=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , par_gh/par_Cm ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp20=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp21=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp22=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (par_kr*exp((kmrgd(1) - par_vr)/par_sr)*(exp((kmrgd(1) - par_vk)/par_sk) + 1))/(par_sr^2*(exp((kmrgd(1) - par_vr)/par_sr) + 1)^2) - (2*par_kr*exp((2*(kmrgd(1) - par_vr))/par_sr)*(exp((kmrgd(1) - par_vk)/par_sk) + 1))/(par_sr^2*(exp((kmrgd(1) - par_vr)/par_sr) + 1)^3) + (par_kr*exp((kmrgd(1) - par_vk)/par_sk)*exp((kmrgd(1) - par_vr)/par_sr))/(par_sk*par_sr*(exp((kmrgd(1) - par_vr)/par_sr) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp23=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (par_kr*exp((kmrgd(1) - par_vr)/par_sr)*(exp((kmrgd(1) - par_vk)/par_sk) + 1))/(par_sr^2*(exp((kmrgd(1) - par_vr)/par_sr) + 1)^2) + (par_kr*exp((kmrgd(1) - par_vr)/par_sr)*(exp((kmrgd(1) - par_vk)/par_sk) + 1)*(kmrgd(1) - par_vr))/(par_sr^3*(exp((kmrgd(1) - par_vr)/par_sr) + 1)^2) - (2*par_kr*exp((2*(kmrgd(1) - par_vr))/par_sr)*(exp((kmrgd(1) - par_vk)/par_sk) + 1)*(kmrgd(1) - par_vr))/(par_sr^3*(exp((kmrgd(1) - par_vr)/par_sr) + 1)^3) + (par_kr*exp((kmrgd(1) - par_vk)/par_sk)*exp((kmrgd(1) - par_vr)/par_sr)*(kmrgd(1) - par_vr))/(par_sk*par_sr^2*(exp((kmrgd(1) - par_vr)/par_sr) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp24=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; - kmrgd(5)*par_gc2 - kmrgd(4)*kmrgd(6)*par_gc1 , 0 , 0 , -kmrgd(6)*par_gc1*(kmrgd(1) - par_eca) , -par_gc2*(kmrgd(1) - par_eca) , -kmrgd(4)*par_gc1*(kmrgd(1) - par_eca) , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp25=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (35*exp(par_va/16 - kmrgd(1)/16))/(64*(exp(par_va/16 - kmrgd(1)/16) + 1)^2) - (35*exp(par_va/8 - kmrgd(1)/8))/(32*(exp(par_va/16 - kmrgd(1)/16) + 1)^3) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp26=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (par_kr*exp((kmrgd(1) - par_vk)/par_sk)*(kmrgd(13) - 1/(exp((kmrgd(1) - par_vr)/par_sr) + 1)))/par_sk^2 + (par_kr*exp((kmrgd(1) - par_vk)/par_sk)*exp((kmrgd(1) - par_vr)/par_sr))/(par_sk*par_sr*(exp((kmrgd(1) - par_vr)/par_sr) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , (par_kr*exp((kmrgd(1) - par_vk)/par_sk))/par_sk ];
hessp27=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (par_kr*exp((kmrgd(1) - par_vk)/par_sk)*(kmrgd(13) - 1/(exp((kmrgd(1) - par_vr)/par_sr) + 1)))/par_sk^2 + (par_kr*exp((kmrgd(1) - par_vk)/par_sk)*(kmrgd(13) - 1/(exp((kmrgd(1) - par_vr)/par_sr) + 1))*(kmrgd(1) - par_vk))/par_sk^3 + (par_kr*exp((kmrgd(1) - par_vk)/par_sk)*exp((kmrgd(1) - par_vr)/par_sr)*(kmrgd(1) - par_vk))/(par_sk^2*par_sr*(exp((kmrgd(1) - par_vr)/par_sr) + 1)^2) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , (par_kr*exp((kmrgd(1) - par_vk)/par_sk)*(kmrgd(1) - par_vk))/par_sk^2 ];
hessp28=[ -1/par_Cm , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp29=[ 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (par_kaf*exp(kmrgd(1)/6 - par_vb/6))/(36*(exp(kmrgd(1)/6 - par_vb/6) + 1)^2) - (par_kaf*exp(kmrgd(1)/3 - par_vb/3))/(18*(exp(kmrgd(1)/6 - par_vb/6) + 1)^3) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; (par_kas*exp(kmrgd(1)/6 - par_vb/6))/(36*(exp(kmrgd(1)/6 - par_vb/6) + 1)^2) - (par_kas*exp(kmrgd(1)/3 - par_vb/3))/(18*(exp(kmrgd(1)/6 - par_vb/6) + 1)^3) , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ; 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 , 0 ];
hessp(:,:,1) =hessp1;
hessp(:,:,2) =hessp2;
hessp(:,:,3) =hessp3;
hessp(:,:,4) =hessp4;
hessp(:,:,5) =hessp5;
hessp(:,:,6) =hessp6;
hessp(:,:,7) =hessp7;
hessp(:,:,8) =hessp8;
hessp(:,:,9) =hessp9;
hessp(:,:,10) =hessp10;
hessp(:,:,11) =hessp11;
hessp(:,:,12) =hessp12;
hessp(:,:,13) =hessp13;
hessp(:,:,14) =hessp14;
hessp(:,:,15) =hessp15;
hessp(:,:,16) =hessp16;
hessp(:,:,17) =hessp17;
hessp(:,:,18) =hessp18;
hessp(:,:,19) =hessp19;
hessp(:,:,20) =hessp20;
hessp(:,:,21) =hessp21;
hessp(:,:,22) =hessp22;
hessp(:,:,23) =hessp23;
hessp(:,:,24) =hessp24;
hessp(:,:,25) =hessp25;
hessp(:,:,26) =hessp26;
hessp(:,:,27) =hessp27;
hessp(:,:,28) =hessp28;
hessp(:,:,29) =hessp29;
%---------------------------------------------------------------------------
function tens3  = der3(t,kmrgd,par_Cm,par_kh,par_kc,par_kk,par_kaf,par_kas,par_kr,par_gna,par_gc1,par_gc2,par_gk,par_gkc,par_gaf,par_gas,par_gh,par_ena,par_eca,par_ek,par_eh,par_el,par_iext,par_vr,par_sr,par_cica,par_va,par_vk,par_sk,par_gl,par_vb)
%---------------------------------------------------------------------------
function tens4  = der4(t,kmrgd,par_Cm,par_kh,par_kc,par_kk,par_kaf,par_kas,par_kr,par_gna,par_gc1,par_gc2,par_gk,par_gkc,par_gaf,par_gas,par_gh,par_ena,par_eca,par_ek,par_eh,par_el,par_iext,par_vr,par_sr,par_cica,par_va,par_vk,par_sk,par_gl,par_vb)
%---------------------------------------------------------------------------
function tens5  = der5(t,kmrgd,par_Cm,par_kh,par_kc,par_kk,par_kaf,par_kas,par_kr,par_gna,par_gc1,par_gc2,par_gk,par_gkc,par_gaf,par_gas,par_gh,par_ena,par_eca,par_ek,par_eh,par_el,par_iext,par_vr,par_sr,par_cica,par_va,par_vk,par_sk,par_gl,par_vb)
